Sync with 2.24.4
[git] / git-submodule.sh
1 #!/bin/sh
2 #
3 # git-submodule.sh: add, init, update or list git submodules
4 #
5 # Copyright (c) 2007 Lars Hjemli
6
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] [--cached]
9    or: $dashless [--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
10    or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
11    or: $dashless [--quiet] init [--] [<path>...]
12    or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
13    or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
14    or: $dashless [--quiet] set-branch (--default|--branch <branch>) [--] <path>
15    or: $dashless [--quiet] set-url [--] <path> <newurl>
16    or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
17    or: $dashless [--quiet] foreach [--recursive] <command>
18    or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
19    or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
20 OPTIONS_SPEC=
21 SUBDIRECTORY_OK=Yes
22 . git-sh-setup
23 . git-parse-remote
24 require_work_tree
25 wt_prefix=$(git rev-parse --show-prefix)
26 cd_to_toplevel
27
28 # Tell the rest of git that any URLs we get don't come
29 # directly from the user, so it can apply policy as appropriate.
30 GIT_PROTOCOL_FROM_USER=0
31 export GIT_PROTOCOL_FROM_USER
32
33 command=
34 branch=
35 force=
36 reference=
37 cached=
38 recursive=
39 init=
40 require_init=
41 files=
42 remote=
43 nofetch=
44 update=
45 prefix=
46 custom_name=
47 depth=
48 progress=
49 dissociate=
50
51 die_if_unmatched ()
52 {
53         if test "$1" = "#unmatched"
54         then
55                 exit ${2:-1}
56         fi
57 }
58
59 #
60 # Print a submodule configuration setting
61 #
62 # $1 = submodule name
63 # $2 = option name
64 # $3 = default value
65 #
66 # Checks in the usual git-config places first (for overrides),
67 # otherwise it falls back on .gitmodules.  This allows you to
68 # distribute project-wide defaults in .gitmodules, while still
69 # customizing individual repositories if necessary.  If the option is
70 # not in .gitmodules either, print a default value.
71 #
72 get_submodule_config () {
73         name="$1"
74         option="$2"
75         default="$3"
76         value=$(git config submodule."$name"."$option")
77         if test -z "$value"
78         then
79                 value=$(git submodule--helper config submodule."$name"."$option")
80         fi
81         printf '%s' "${value:-$default}"
82 }
83
84 isnumber()
85 {
86         n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
87 }
88
89 # Given a full hex object ID, is this the zero OID?
90 is_zero_oid () {
91         echo "$1" | sane_egrep '^0+$' >/dev/null 2>&1
92 }
93
94 # Sanitize the local git environment for use within a submodule. We
95 # can't simply use clear_local_git_env since we want to preserve some
96 # of the settings from GIT_CONFIG_PARAMETERS.
97 sanitize_submodule_env()
98 {
99         save_config=$GIT_CONFIG_PARAMETERS
100         clear_local_git_env
101         GIT_CONFIG_PARAMETERS=$save_config
102         export GIT_CONFIG_PARAMETERS
103 }
104
105 #
106 # Add a new submodule to the working tree, .gitmodules and the index
107 #
108 # $@ = repo path
109 #
110 # optional branch is stored in global branch variable
111 #
112 cmd_add()
113 {
114         # parse $args after "submodule ... add".
115         reference_path=
116         while test $# -ne 0
117         do
118                 case "$1" in
119                 -b | --branch)
120                         case "$2" in '') usage ;; esac
121                         branch=$2
122                         shift
123                         ;;
124                 -f | --force)
125                         force=$1
126                         ;;
127                 -q|--quiet)
128                         GIT_QUIET=1
129                         ;;
130                 --progress)
131                         progress=1
132                         ;;
133                 --reference)
134                         case "$2" in '') usage ;; esac
135                         reference_path=$2
136                         shift
137                         ;;
138                 --reference=*)
139                         reference_path="${1#--reference=}"
140                         ;;
141                 --dissociate)
142                         dissociate=1
143                         ;;
144                 --name)
145                         case "$2" in '') usage ;; esac
146                         custom_name=$2
147                         shift
148                         ;;
149                 --depth)
150                         case "$2" in '') usage ;; esac
151                         depth="--depth=$2"
152                         shift
153                         ;;
154                 --depth=*)
155                         depth=$1
156                         ;;
157                 --)
158                         shift
159                         break
160                         ;;
161                 -*)
162                         usage
163                         ;;
164                 *)
165                         break
166                         ;;
167                 esac
168                 shift
169         done
170
171         if ! git submodule--helper config --check-writeable >/dev/null 2>&1
172         then
173                  die "$(eval_gettext "please make sure that the .gitmodules file is in the working tree")"
174         fi
175
176         if test -n "$reference_path"
177         then
178                 is_absolute_path "$reference_path" ||
179                 reference_path="$wt_prefix$reference_path"
180
181                 reference="--reference=$reference_path"
182         fi
183
184         repo=$1
185         sm_path=$2
186
187         if test -z "$sm_path"; then
188                 sm_path=$(printf '%s\n' "$repo" |
189                         sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
190         fi
191
192         if test -z "$repo" || test -z "$sm_path"; then
193                 usage
194         fi
195
196         is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
197
198         # assure repo is absolute or relative to parent
199         case "$repo" in
200         ./*|../*)
201                 test -z "$wt_prefix" ||
202                 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
203
204                 # dereference source url relative to parent's url
205                 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
206                 ;;
207         *:*|/*)
208                 # absolute url
209                 realrepo=$repo
210                 ;;
211         *)
212                 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
213         ;;
214         esac
215
216         # normalize path:
217         # multiple //; leading ./; /./; /../; trailing /
218         sm_path=$(printf '%s/\n' "$sm_path" |
219                 sed -e '
220                         s|//*|/|g
221                         s|^\(\./\)*||
222                         s|/\(\./\)*|/|g
223                         :start
224                         s|\([^/]*\)/\.\./||
225                         tstart
226                         s|/*$||
227                 ')
228         if test -z "$force"
229         then
230                 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
231                 die "$(eval_gettext "'\$sm_path' already exists in the index")"
232         else
233                 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
234                 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
235         fi
236
237         if test -d "$sm_path" &&
238                 test -z $(git -C "$sm_path" rev-parse --show-cdup 2>/dev/null)
239         then
240             git -C "$sm_path" rev-parse --verify -q HEAD >/dev/null ||
241             die "$(eval_gettext "'\$sm_path' does not have a commit checked out")"
242         fi
243
244         if test -z "$force" &&
245                 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
246         then
247                 eval_gettextln "The following path is ignored by one of your .gitignore files:
248 \$sm_path
249 Use -f if you really want to add it." >&2
250                 exit 1
251         fi
252
253         if test -n "$custom_name"
254         then
255                 sm_name="$custom_name"
256         else
257                 sm_name="$sm_path"
258         fi
259
260         if ! git submodule--helper check-name "$sm_name"
261         then
262                 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
263         fi
264
265         # perhaps the path exists and is already a git repo, else clone it
266         if test -e "$sm_path"
267         then
268                 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
269                 then
270                         eval_gettextln "Adding existing repo at '\$sm_path' to the index"
271                 else
272                         die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
273                 fi
274
275         else
276                 if test -d ".git/modules/$sm_name"
277                 then
278                         if test -z "$force"
279                         then
280                                 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
281                                 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^,"  ", -e s,' (fetch)',, >&2
282                                 die "$(eval_gettextln "\
283 If you want to reuse this local git directory instead of cloning again from
284   \$realrepo
285 use the '--force' option. If the local git directory is not the correct repo
286 or you are unsure what this means choose another name with the '--name' option.")"
287                         else
288                                 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
289                         fi
290                 fi
291                 git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${dissociate:+"--dissociate"} ${depth:+"$depth"} || exit
292                 (
293                         sanitize_submodule_env
294                         cd "$sm_path" &&
295                         # ash fails to wordsplit ${branch:+-b "$branch"...}
296                         case "$branch" in
297                         '') git checkout -f -q ;;
298                         ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
299                         esac
300                 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
301         fi
302         git config submodule."$sm_name".url "$realrepo"
303
304         git add --no-warn-embedded-repo $force "$sm_path" ||
305         die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
306
307         git submodule--helper config submodule."$sm_name".path "$sm_path" &&
308         git submodule--helper config submodule."$sm_name".url "$repo" &&
309         if test -n "$branch"
310         then
311                 git submodule--helper config submodule."$sm_name".branch "$branch"
312         fi &&
313         git add --force .gitmodules ||
314         die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
315
316         # NEEDSWORK: In a multi-working-tree world, this needs to be
317         # set in the per-worktree config.
318         if git config --get submodule.active >/dev/null
319         then
320                 # If the submodule being adding isn't already covered by the
321                 # current configured pathspec, set the submodule's active flag
322                 if ! git submodule--helper is-active "$sm_path"
323                 then
324                         git config submodule."$sm_name".active "true"
325                 fi
326         else
327                 git config submodule."$sm_name".active "true"
328         fi
329 }
330
331 #
332 # Execute an arbitrary command sequence in each checked out
333 # submodule
334 #
335 # $@ = command to execute
336 #
337 cmd_foreach()
338 {
339         # parse $args after "submodule ... foreach".
340         while test $# -ne 0
341         do
342                 case "$1" in
343                 -q|--quiet)
344                         GIT_QUIET=1
345                         ;;
346                 --recursive)
347                         recursive=1
348                         ;;
349                 -*)
350                         usage
351                         ;;
352                 *)
353                         break
354                         ;;
355                 esac
356                 shift
357         done
358
359         git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper foreach ${GIT_QUIET:+--quiet} ${recursive:+--recursive} -- "$@"
360 }
361
362 #
363 # Register submodules in .git/config
364 #
365 # $@ = requested paths (default to all)
366 #
367 cmd_init()
368 {
369         # parse $args after "submodule ... init".
370         while test $# -ne 0
371         do
372                 case "$1" in
373                 -q|--quiet)
374                         GIT_QUIET=1
375                         ;;
376                 --)
377                         shift
378                         break
379                         ;;
380                 -*)
381                         usage
382                         ;;
383                 *)
384                         break
385                         ;;
386                 esac
387                 shift
388         done
389
390         git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} -- "$@"
391 }
392
393 #
394 # Unregister submodules from .git/config and remove their work tree
395 #
396 cmd_deinit()
397 {
398         # parse $args after "submodule ... deinit".
399         deinit_all=
400         while test $# -ne 0
401         do
402                 case "$1" in
403                 -f|--force)
404                         force=$1
405                         ;;
406                 -q|--quiet)
407                         GIT_QUIET=1
408                         ;;
409                 --all)
410                         deinit_all=t
411                         ;;
412                 --)
413                         shift
414                         break
415                         ;;
416                 -*)
417                         usage
418                         ;;
419                 *)
420                         break
421                         ;;
422                 esac
423                 shift
424         done
425
426         git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} -- "$@"
427 }
428
429 is_tip_reachable () (
430         sanitize_submodule_env &&
431         cd "$1" &&
432         rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
433         test -z "$rev"
434 )
435
436 fetch_in_submodule () (
437         sanitize_submodule_env &&
438         cd "$1" &&
439         case "$2" in
440         '')
441                 git fetch ;;
442         *)
443                 shift
444                 git fetch $(get_default_remote) "$@" ;;
445         esac
446 )
447
448 #
449 # Update each submodule path to correct revision, using clone and checkout as needed
450 #
451 # $@ = requested paths (default to all)
452 #
453 cmd_update()
454 {
455         # parse $args after "submodule ... update".
456         while test $# -ne 0
457         do
458                 case "$1" in
459                 -q|--quiet)
460                         GIT_QUIET=1
461                         ;;
462                 -v)
463                         GIT_QUIET=0
464                         ;;
465                 --progress)
466                         progress=1
467                         ;;
468                 -i|--init)
469                         init=1
470                         ;;
471                 --require-init)
472                         init=1
473                         require_init=1
474                         ;;
475                 --remote)
476                         remote=1
477                         ;;
478                 -N|--no-fetch)
479                         nofetch=1
480                         ;;
481                 -f|--force)
482                         force=$1
483                         ;;
484                 -r|--rebase)
485                         update="rebase"
486                         ;;
487                 --reference)
488                         case "$2" in '') usage ;; esac
489                         reference="--reference=$2"
490                         shift
491                         ;;
492                 --reference=*)
493                         reference="$1"
494                         ;;
495                 --dissociate)
496                         dissociate=1
497                         ;;
498                 -m|--merge)
499                         update="merge"
500                         ;;
501                 --recursive)
502                         recursive=1
503                         ;;
504                 --checkout)
505                         update="checkout"
506                         ;;
507                 --recommend-shallow)
508                         recommend_shallow="--recommend-shallow"
509                         ;;
510                 --no-recommend-shallow)
511                         recommend_shallow="--no-recommend-shallow"
512                         ;;
513                 --depth)
514                         case "$2" in '') usage ;; esac
515                         depth="--depth=$2"
516                         shift
517                         ;;
518                 --depth=*)
519                         depth=$1
520                         ;;
521                 -j|--jobs)
522                         case "$2" in '') usage ;; esac
523                         jobs="--jobs=$2"
524                         shift
525                         ;;
526                 --jobs=*)
527                         jobs=$1
528                         ;;
529                 --)
530                         shift
531                         break
532                         ;;
533                 -*)
534                         usage
535                         ;;
536                 *)
537                         break
538                         ;;
539                 esac
540                 shift
541         done
542
543         if test -n "$init"
544         then
545                 cmd_init "--" "$@" || return
546         fi
547
548         {
549         git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
550                 ${progress:+"--progress"} \
551                 ${wt_prefix:+--prefix "$wt_prefix"} \
552                 ${prefix:+--recursive-prefix "$prefix"} \
553                 ${update:+--update "$update"} \
554                 ${reference:+"$reference"} \
555                 ${dissociate:+"--dissociate"} \
556                 ${depth:+--depth "$depth"} \
557                 ${require_init:+--require-init} \
558                 $recommend_shallow \
559                 $jobs \
560                 -- \
561                 "$@" || echo "#unmatched" $?
562         } | {
563         err=
564         while read -r quickabort sha1 just_cloned sm_path
565         do
566                 die_if_unmatched "$quickabort" "$sha1"
567
568                 git submodule--helper ensure-core-worktree "$sm_path" || exit 1
569
570                 update_module=$(git submodule--helper update-module-mode $just_cloned "$sm_path" $update)
571
572                 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
573
574                 if test $just_cloned -eq 1
575                 then
576                         subsha1=
577                 else
578                         subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
579                                 git rev-parse --verify HEAD) ||
580                         die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
581                 fi
582
583                 if test -n "$remote"
584                 then
585                         branch=$(git submodule--helper remote-branch "$sm_path")
586                         if test -z "$nofetch"
587                         then
588                                 # Fetch remote before determining tracking $sha1
589                                 fetch_in_submodule "$sm_path" $depth ||
590                                 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
591                         fi
592                         remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
593                         sha1=$(sanitize_submodule_env; cd "$sm_path" &&
594                                 git rev-parse --verify "${remote_name}/${branch}") ||
595                         die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
596                 fi
597
598                 if test "$subsha1" != "$sha1" || test -n "$force"
599                 then
600                         subforce=$force
601                         # If we don't already have a -f flag and the submodule has never been checked out
602                         if test -z "$subsha1" && test -z "$force"
603                         then
604                                 subforce="-f"
605                         fi
606
607                         if test -z "$nofetch"
608                         then
609                                 # Run fetch only if $sha1 isn't present or it
610                                 # is not reachable from a ref.
611                                 is_tip_reachable "$sm_path" "$sha1" ||
612                                 fetch_in_submodule "$sm_path" $depth ||
613                                 say "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'; trying to directly fetch \$sha1:")"
614
615                                 # Now we tried the usual fetch, but $sha1 may
616                                 # not be reachable from any of the refs
617                                 is_tip_reachable "$sm_path" "$sha1" ||
618                                 fetch_in_submodule "$sm_path" $depth "$sha1" ||
619                                 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
620                         fi
621
622                         must_die_on_failure=
623                         case "$update_module" in
624                         checkout)
625                                 command="git checkout $subforce -q"
626                                 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
627                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
628                                 ;;
629                         rebase)
630                                 command="git rebase"
631                                 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
632                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
633                                 must_die_on_failure=yes
634                                 ;;
635                         merge)
636                                 command="git merge"
637                                 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
638                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
639                                 must_die_on_failure=yes
640                                 ;;
641                         !*)
642                                 command="${update_module#!}"
643                                 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
644                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
645                                 must_die_on_failure=yes
646                                 ;;
647                         *)
648                                 die "$(eval_gettext "Invalid update mode '$update_module' for submodule path '$path'")"
649                         esac
650
651                         if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
652                         then
653                                 say "$say_msg"
654                         elif test -n "$must_die_on_failure"
655                         then
656                                 die_with_status 2 "$die_msg"
657                         else
658                                 err="${err};$die_msg"
659                                 continue
660                         fi
661                 fi
662
663                 if test -n "$recursive"
664                 then
665                         (
666                                 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
667                                 wt_prefix=
668                                 sanitize_submodule_env
669                                 cd "$sm_path" &&
670                                 eval cmd_update
671                         )
672                         res=$?
673                         if test $res -gt 0
674                         then
675                                 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
676                                 if test $res -ne 2
677                                 then
678                                         err="${err};$die_msg"
679                                         continue
680                                 else
681                                         die_with_status $res "$die_msg"
682                                 fi
683                         fi
684                 fi
685         done
686
687         if test -n "$err"
688         then
689                 OIFS=$IFS
690                 IFS=';'
691                 for e in $err
692                 do
693                         if test -n "$e"
694                         then
695                                 echo >&2 "$e"
696                         fi
697                 done
698                 IFS=$OIFS
699                 exit 1
700         fi
701         }
702 }
703
704 #
705 # Configures a submodule's default branch
706 #
707 # $@ = requested path
708 #
709 cmd_set_branch() {
710         unset_branch=false
711         branch=
712
713         while test $# -ne 0
714         do
715                 case "$1" in
716                 -q|--quiet)
717                         # we don't do anything with this but we need to accept it
718                         ;;
719                 -d|--default)
720                         unset_branch=true
721                         ;;
722                 -b|--branch)
723                         case "$2" in '') usage ;; esac
724                         branch=$2
725                         shift
726                         ;;
727                 --)
728                         shift
729                         break
730                         ;;
731                 -*)
732                         usage
733                         ;;
734                 *)
735                         break
736                         ;;
737                 esac
738                 shift
739         done
740
741         if test $# -ne 1
742         then
743                 usage
744         fi
745
746         # we can't use `git submodule--helper name` here because internally, it
747         # hashes the path so a trailing slash could lead to an unintentional no match
748         name="$(git submodule--helper list "$1" | cut -f2)"
749         if test -z "$name"
750         then
751                 exit 1
752         fi
753
754         test -n "$branch"; has_branch=$?
755         test "$unset_branch" = true; has_unset_branch=$?
756
757         if test $((!$has_branch != !$has_unset_branch)) -eq 0
758         then
759                 usage
760         fi
761
762         if test $has_branch -eq 0
763         then
764                 git submodule--helper config submodule."$name".branch "$branch"
765         else
766                 git submodule--helper config --unset submodule."$name".branch
767         fi
768 }
769
770 #
771 # Configures a submodule's remote url
772 #
773 # $@ = requested path, requested url
774 #
775 cmd_set_url() {
776         while test $# -ne 0
777         do
778                 case "$1" in
779                 -q|--quiet)
780                         GIT_QUIET=1
781                         ;;
782                 --)
783                         shift
784                         break
785                         ;;
786                 -*)
787                         usage
788                         ;;
789                 *)
790                         break
791                         ;;
792                 esac
793                 shift
794         done
795
796         if test $# -ne 2
797         then
798                 usage
799         fi
800
801         # we can't use `git submodule--helper name` here because internally, it
802         # hashes the path so a trailing slash could lead to an unintentional no match
803         name="$(git submodule--helper list "$1" | cut -f2)"
804         if test -z "$name"
805         then
806                 exit 1
807         fi
808
809         url="$2"
810         if test -z "$url"
811         then
812                 exit 1
813         fi
814
815         git submodule--helper config submodule."$name".url "$url"
816         git submodule--helper sync ${GIT_QUIET:+--quiet} "$name"
817 }
818
819 #
820 # Show commit summary for submodules in index or working tree
821 #
822 # If '--cached' is given, show summary between index and given commit,
823 # or between working tree and given commit
824 #
825 # $@ = [commit (default 'HEAD'),] requested paths (default all)
826 #
827 cmd_summary() {
828         summary_limit=-1
829         for_status=
830         diff_cmd=diff-index
831
832         # parse $args after "submodule ... summary".
833         while test $# -ne 0
834         do
835                 case "$1" in
836                 --cached)
837                         cached="$1"
838                         ;;
839                 --files)
840                         files="$1"
841                         ;;
842                 --for-status)
843                         for_status="$1"
844                         ;;
845                 -n|--summary-limit)
846                         summary_limit="$2"
847                         isnumber "$summary_limit" || usage
848                         shift
849                         ;;
850                 --summary-limit=*)
851                         summary_limit="${1#--summary-limit=}"
852                         isnumber "$summary_limit" || usage
853                         ;;
854                 --)
855                         shift
856                         break
857                         ;;
858                 -*)
859                         usage
860                         ;;
861                 *)
862                         break
863                         ;;
864                 esac
865                 shift
866         done
867
868         test $summary_limit = 0 && return
869
870         if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
871         then
872                 head=$rev
873                 test $# = 0 || shift
874         elif test -z "$1" || test "$1" = "HEAD"
875         then
876                 # before the first commit: compare with an empty tree
877                 head=$(git hash-object -w -t tree --stdin </dev/null)
878                 test -z "$1" || shift
879         else
880                 head="HEAD"
881         fi
882
883         if [ -n "$files" ]
884         then
885                 test -n "$cached" &&
886                 die "$(gettext "The --cached option cannot be used with the --files option")"
887                 diff_cmd=diff-files
888                 head=
889         fi
890
891         cd_to_toplevel
892         eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
893         # Get modified modules cared by user
894         modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
895                 sane_egrep '^:([0-7]* )?160000' |
896                 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
897                 do
898                         # Always show modules deleted or type-changed (blob<->module)
899                         if test "$status" = D || test "$status" = T
900                         then
901                                 printf '%s\n' "$sm_path"
902                                 continue
903                         fi
904                         # Respect the ignore setting for --for-status.
905                         if test -n "$for_status"
906                         then
907                                 name=$(git submodule--helper name "$sm_path")
908                                 ignore_config=$(get_submodule_config "$name" ignore none)
909                                 test $status != A && test $ignore_config = all && continue
910                         fi
911                         # Also show added or modified modules which are checked out
912                         GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
913                         printf '%s\n' "$sm_path"
914                 done
915         )
916
917         test -z "$modules" && return
918
919         git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
920         sane_egrep '^:([0-7]* )?160000' |
921         cut -c2- |
922         while read -r mod_src mod_dst sha1_src sha1_dst status name
923         do
924                 if test -z "$cached" &&
925                         is_zero_oid $sha1_dst
926                 then
927                         case "$mod_dst" in
928                         160000)
929                                 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
930                                 ;;
931                         100644 | 100755 | 120000)
932                                 sha1_dst=$(git hash-object $name)
933                                 ;;
934                         000000)
935                                 ;; # removed
936                         *)
937                                 # unexpected type
938                                 eval_gettextln "unexpected mode \$mod_dst" >&2
939                                 continue ;;
940                         esac
941                 fi
942                 missing_src=
943                 missing_dst=
944
945                 test $mod_src = 160000 &&
946                 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
947                 missing_src=t
948
949                 test $mod_dst = 160000 &&
950                 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
951                 missing_dst=t
952
953                 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
954
955                 total_commits=
956                 case "$missing_src,$missing_dst" in
957                 t,)
958                         errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commit \$sha1_src")"
959                         ;;
960                 ,t)
961                         errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commit \$sha1_dst")"
962                         ;;
963                 t,t)
964                         errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
965                         ;;
966                 *)
967                         errmsg=
968                         total_commits=$(
969                         if test $mod_src = 160000 && test $mod_dst = 160000
970                         then
971                                 range="$sha1_src...$sha1_dst"
972                         elif test $mod_src = 160000
973                         then
974                                 range=$sha1_src
975                         else
976                                 range=$sha1_dst
977                         fi
978                         GIT_DIR="$name/.git" \
979                         git rev-list --first-parent $range -- | wc -l
980                         )
981                         total_commits=" ($(($total_commits + 0)))"
982                         ;;
983                 esac
984
985                 sha1_abbr_src=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_src 2>/dev/null ||
986                         echo $sha1_src | cut -c1-7)
987                 sha1_abbr_dst=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_dst 2>/dev/null ||
988                         echo $sha1_dst | cut -c1-7)
989
990                 if test $status = T
991                 then
992                         blob="$(gettext "blob")"
993                         submodule="$(gettext "submodule")"
994                         if test $mod_dst = 160000
995                         then
996                                 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
997                         else
998                                 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
999                         fi
1000                 else
1001                         echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1002                 fi
1003                 if test -n "$errmsg"
1004                 then
1005                         # Don't give error msg for modification whose dst is not submodule
1006                         # i.e. deleted or changed to blob
1007                         test $mod_dst = 160000 && echo "$errmsg"
1008                 else
1009                         if test $mod_src = 160000 && test $mod_dst = 160000
1010                         then
1011                                 limit=
1012                                 test $summary_limit -gt 0 && limit="-$summary_limit"
1013                                 GIT_DIR="$name/.git" \
1014                                 git log $limit --pretty='format:  %m %s' \
1015                                 --first-parent $sha1_src...$sha1_dst
1016                         elif test $mod_dst = 160000
1017                         then
1018                                 GIT_DIR="$name/.git" \
1019                                 git log --pretty='format:  > %s' -1 $sha1_dst
1020                         else
1021                                 GIT_DIR="$name/.git" \
1022                                 git log --pretty='format:  < %s' -1 $sha1_src
1023                         fi
1024                         echo
1025                 fi
1026                 echo
1027         done
1028 }
1029 #
1030 # List all submodules, prefixed with:
1031 #  - submodule not initialized
1032 #  + different revision checked out
1033 #
1034 # If --cached was specified the revision in the index will be printed
1035 # instead of the currently checked out revision.
1036 #
1037 # $@ = requested paths (default to all)
1038 #
1039 cmd_status()
1040 {
1041         # parse $args after "submodule ... status".
1042         while test $# -ne 0
1043         do
1044                 case "$1" in
1045                 -q|--quiet)
1046                         GIT_QUIET=1
1047                         ;;
1048                 --cached)
1049                         cached=1
1050                         ;;
1051                 --recursive)
1052                         recursive=1
1053                         ;;
1054                 --)
1055                         shift
1056                         break
1057                         ;;
1058                 -*)
1059                         usage
1060                         ;;
1061                 *)
1062                         break
1063                         ;;
1064                 esac
1065                 shift
1066         done
1067
1068         git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} -- "$@"
1069 }
1070 #
1071 # Sync remote urls for submodules
1072 # This makes the value for remote.$remote.url match the value
1073 # specified in .gitmodules.
1074 #
1075 cmd_sync()
1076 {
1077         while test $# -ne 0
1078         do
1079                 case "$1" in
1080                 -q|--quiet)
1081                         GIT_QUIET=1
1082                         shift
1083                         ;;
1084                 --recursive)
1085                         recursive=1
1086                         shift
1087                         ;;
1088                 --)
1089                         shift
1090                         break
1091                         ;;
1092                 -*)
1093                         usage
1094                         ;;
1095                 *)
1096                         break
1097                         ;;
1098                 esac
1099         done
1100
1101         git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} -- "$@"
1102 }
1103
1104 cmd_absorbgitdirs()
1105 {
1106         git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1107 }
1108
1109 # This loop parses the command line arguments to find the
1110 # subcommand name to dispatch.  Parsing of the subcommand specific
1111 # options are primarily done by the subcommand implementations.
1112 # Subcommand specific options such as --branch and --cached are
1113 # parsed here as well, for backward compatibility.
1114
1115 while test $# != 0 && test -z "$command"
1116 do
1117         case "$1" in
1118         add | foreach | init | deinit | update | set-branch | set-url | status | summary | sync | absorbgitdirs)
1119                 command=$1
1120                 ;;
1121         -q|--quiet)
1122                 GIT_QUIET=1
1123                 ;;
1124         -b|--branch)
1125                 case "$2" in
1126                 '')
1127                         usage
1128                         ;;
1129                 esac
1130                 branch="$2"; shift
1131                 ;;
1132         --cached)
1133                 cached="$1"
1134                 ;;
1135         --)
1136                 break
1137                 ;;
1138         -*)
1139                 usage
1140                 ;;
1141         *)
1142                 break
1143                 ;;
1144         esac
1145         shift
1146 done
1147
1148 # No command word defaults to "status"
1149 if test -z "$command"
1150 then
1151     if test $# = 0
1152     then
1153         command=status
1154     else
1155         usage
1156     fi
1157 fi
1158
1159 # "-b branch" is accepted only by "add" and "set-branch"
1160 if test -n "$branch" && (test "$command" != add || test "$command" != set-branch)
1161 then
1162         usage
1163 fi
1164
1165 # "--cached" is accepted only by "status" and "summary"
1166 if test -n "$cached" && test "$command" != status && test "$command" != summary
1167 then
1168         usage
1169 fi
1170
1171 "cmd_$(echo $command | sed -e s/-/_/g)" "$@"